/**
 * Docker Volumes interface.
 *
 * @stability stable
 */
export interface DockerVolumes {
    /**
     * EC2 Runner Host Path.
     *
     * @stability stable
     * @example
     *
     * - /tmp/cahce
     * more detail see https://docs.gitlab.com/runner/configuration/advanced-configuration.html#the-runnersdocker-section
     */
    readonly hostPath: string;
    /**
     * Job Runtime Container Path Host Path.
     *
     * @stability stable
     * @example
     *
     * - /tmp/cahce
     * more detail see https://docs.gitlab.com/runner/configuration/advanced-configuration.html#the-runnersdocker-section
     */
    readonly containerPath: string;
}
